function love.load(arg)
if arg[#arg] == "-debug" then require("mobdebug").start() end

require("load_tiles")
tile = {}
load_tiles()--loads the tile set

--origin x and y points
ox = 400
oy = -400

--the tiles widths/heights (rectangle they are in)
tile_width = 128
tile_height = 64

--creating tile map
-- value 0 means no tile, 1 means tile, 2...etc
tile_set = {}
--indexing from 1-20 (not zero but i might need to change that?)
for a=1, 20, 1 do
	tile_set[a] = {}
	for b=1,20,1 do
		tile_set[a][b] = 10
	end
end

tile_set[1][1] = 13
tile_set[20][20] = 12
tile_set[1][20] = 11
tile_set[20][1] = 11


--map size; ie, 4x4
tile_set_size = 20


--tile outline image (not an actual tile so i guess no need to put in tile{}
--tile_outline = love.graphics.newImage('tile_outline.png')

day = 0--counting the number of day/night cycles

actions_given = 10--actions given per cycle
actions = actions_given--available actions

selector = 10--putting tile selector when clicking on an area

text = ""

--setting mouse position coords to 0,0
ax = 0
by = 0

end
--



function love.update(dt)
if love.mouse.isDown('l') then
	x,y = love.mouse.getPosition()
	ox = x - mouse_distx--mouse dist from love.mousePressed
	oy = y - mouse_disty
end
end
--



function love.draw()
love.graphics.setColor(255, 255, 255, 255)--just for shits
love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)

--first loop gets the value of the first index (b) and the second loop gets each value d of each index of b
for a,b in ipairs(tile_set) do--for index,value...
  for c,d in ipairs(b) do--for index,value...
	  --draw_tile(a,c,tile[d])--draw xxx at point a,c
    draw_tile(a,c,tile[math.ceil(d/10-0.5)][d%10])--needed to split 13 to 1,3
   end
end
--
--draw yellow outline on tile-area mouse is over (converting the tile_set to coords)

ax,by = love.mouse.getPosition()
ax,by = to_tile_position(ax,by)--mouse x,y on screen to the corresponding tile position
draw_tile(ax,by,tile_outline)--draw the tile_outline at tile ax,by


--temp side buttons
love.graphics.rectangle("fill",25,150,64,64)
love.graphics.rectangle("fill",25,250,64,64)
love.graphics.rectangle("fill",25,350,64,64)

--seeeed thing
if draw_seed_box == true then
love.graphics.rectangle("fill", 128, 64, 600, 600)
end
--
--for debugging change 'text' to whatever want to print
love.graphics.print(text,50,200,0,2,2)
end
--

--chanege to get tile height then half, etc
function draw_tile(ax,by,tile)--draws tile tile at tile_set[ax][by]
--love.graphics.draw(tile, ox+((ax-by)*(tile_width/2)),oy+((ax+by)*(tile_height/2)))
--hegts = tile:getHeight()

love.graphics.draw(tile, ox+((ax-by)*(tile_width/2)),oy+((ax+by)*(tile_height/2))-(tile:getHeight()-64))

end
--

function day_cycle()
actions = actions_given
for a,b in pairs(tile_set) do
	for c,d in pairs(b) do 
		--change tile depending on type. 
		--eg, if is tile 2, change to a 3 etc
    --[[
		if d == 2 then
			tile_set[a][c] = tile_set[a][c]+1
		end
    if d == 3 then
      tile_set[a][c] = tile_set[a][c]+1
    end
    if d == 4 then
      tile_set[a][c] = tile_set[a][c]+1
    end
    if d == 5 then
      tile_set[a][c] = tile_set[a][c]+1      
    end
    ]]
    if (d%10) < 4 then
      tile_set[a][c] = tile_set[a][c]+1
    end
	end
end
end

function to_tile_position(x,y)--converts x,y points to tile points
--find the distance from the originxy
mouse_distX = x-ox-64
mouse_distY = y-oy-32
--converting the x/y to tile positions (from in the tile_set)
ax = ((mouse_distX/(tile_width/2) + mouse_distY/(tile_height/2)) /2)
by = ((mouse_distY/(tile_height/2) - mouse_distX/(tile_width/2)) /2)
--round up to nearst full number
--ax = math.ceil(ax-0.5)
ax = math.floor(ax+0.5)--samesame
by = math.floor(by+0.5)--same same
--by = math.ceil(by-0.5)
if ax >= 1 and ax <= tile_set_size and by >= 1 and by <= tile_set_size then--checking bounds
  return ax,by--nearest tile position from mouse location(tile mouse is on)
else
  return 1,1--if out of bounds return 1,1
end
end
--

function love.mousepressed(x,y,button)--need a bit of a redesign here for tracking mouse movement on press
  if button == 'l' then
    mouse_startx = x--still need these 2, probs can remove later, check the mouse.released
    mouse_starty = y
	
	--this is required for the movement; see .update
	mouse_distx = x-ox--dist from ox
	mouse_disty = y-oy
	end
end
--

function love.mousereleased(x,y,button)
	if button == 'l' then
    --if mouse hasn't moved position since button was Down then add block else just move board
		if mouse_startx > x-5 and mouse_startx < x+5 then--maybe have a range of 5-10
			if mouse_starty > y-5 and mouse_starty < y+5 then
				if x >= 89 then--not on the side menu part
				--if so then mouse has not moved...
					--need to check for action poits use and stuff
					ax,by = to_tile_position(x,y)
					tile_set[ax][by] = selector
				elseif y >= 150 then
          if y <= 214 then
            --do whatever that first button does?
            selector = 11
            day_cycle()
          elseif y > 250 and y <= 314 then
            --second button action?
            selector = 20
					elseif y > 350 and y<= 414 then
            --third button action?
            selector = 30
            draw_seed_box = true
          end
				end
			end
		end	
	end
end
--
